/****************************************************************
 *
 * MIDI_SharpFlatAdjust.c
 *
 * Authors: Ben McQuiston
 *
 * C function to adjust a MIDI number if the piece is in a signature
 *  that has sharps or flats
 * Last Revision: 
 *       - November 13, 2006
 *  
 *****************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define CNOTE 12
#define BNOTE 11
#define ANOTE 9
#define GNOTE 7
#define FNOTE 5
#define ENOTE 4
#define DNOTE 2



/****************************************************************
 *
 * int MIDI_SharpFlatAdjust(int keySig, int MIDInum)
 *
 * Arguments: keySig: 1-7 = sharps, 0 = no sharps or flats
 *               -1..-7 = flats
 *
 * Return value: Sharp or Flat corrected MIDI number
 *
 * This function adds or subtracts one based on if it needs to be
 *   sharped or flatted.
 *
 *****************************************************************/

int 
MIDI_SharpFlatAdjust(int keySig, int MIDInum)
{
  int i = 0;
  int temp = 0;
  int check = 0;
  printf("Adjusting for key signature... \n");
  printf("MIDInum = %d, keySig = %d\n",MIDInum,keySig);

  if (keySig == 0){
    return MIDInum;
  }
  else{
    printf("HELLO\n");
	while(check == 0){
      if ((MIDInum % (CNOTE + (12 * i)) == 0) && (MIDInum / (CNOTE + (12 * i)) == 1)){
        temp = CNOTE;
		printf("Cnote..., i = %d\n",i);
		check = 1;
      }
      else if((MIDInum % (BNOTE + (12 * i)) == 0) && (MIDInum / (BNOTE + (12 * i)) == 1)){
        temp = BNOTE;
		printf("Bnote...\n");
		check = 1;
      }
      else if((MIDInum % (ANOTE + (12 * i)) == 0) && (MIDInum / (ANOTE + (12 * i)) == 1)){
        temp = ANOTE;
		printf("Anote...\n");
		check = 1;
      }
      else if((MIDInum % (GNOTE + (12 * i)) == 0) && (MIDInum / (GNOTE + (12 * i)) == 1)){
        temp = GNOTE;  
		printf("Gnote...\n");
		check = 1;
	  } 
      else if((MIDInum % (FNOTE + (12 * i)) == 0) && (MIDInum / (FNOTE + (12 * i)) == 1)){
        temp = FNOTE;
        printf("Fnote..i = %d\n",i);
		check = 1;
      }
      else if((MIDInum % (ENOTE + (12 * i)) == 0) && (MIDInum / (ENOTE + (12 * i)) == 1)){
        temp = ENOTE;
		printf("Enote...\n");
		check = 1;
      }
      else if((MIDInum % (DNOTE + (12 * i)) == 0) && (MIDInum / (DNOTE + (12 * i)) == 1)){
        temp = DNOTE;
		printf("Dnote...\n");
		check = 1;
      }
	  i++;
    }

    if (keySig == 1 && temp == FNOTE){
      return MIDInum + 1;
    }
    else if (keySig == 2 && (temp == FNOTE || temp == CNOTE)){
      return MIDInum + 1;
    }
    else if (keySig == 3 && (temp == FNOTE || temp == CNOTE || temp == GNOTE)){
      return MIDInum + 1;
    }
    else if (keySig == 4 && (temp == FNOTE || temp == CNOTE || temp == GNOTE ||
                                 temp == DNOTE)){
      return MIDInum + 1;
    }
    else if (keySig == 5 && (temp == FNOTE || temp == CNOTE || temp == GNOTE ||
                                 temp == DNOTE || temp == ANOTE)){
      return MIDInum + 1;
    } 
    else if (keySig == 6 && (temp == FNOTE || temp == CNOTE || temp == GNOTE ||
                                 temp == DNOTE || temp == ANOTE || temp == ENOTE)){
      return MIDInum + 1;
    }
    else if (keySig == 7 && (temp == FNOTE || temp == CNOTE || temp == GNOTE ||
                temp == DNOTE || temp == ANOTE || temp == ENOTE || temp == BNOTE)){
      return MIDInum + 1;
    }
	/*Checking for flats here...*/
	else if (keySig == -1 && temp == BNOTE){
      return MIDInum - 1;
    }
    else if (keySig == -2 && (temp == BNOTE || temp == ENOTE)){
      return MIDInum - 1;
    }
    else if (keySig == -3 && (temp == BNOTE || temp == ENOTE || temp == ANOTE)){
      return MIDInum - 1;
    }
    else if (keySig == -4 && (temp == BNOTE || temp == ENOTE || temp == ANOTE ||
                                 temp == DNOTE)){
      return MIDInum - 1;
    }
    else if (keySig == -5 && (temp == BNOTE || temp == ENOTE || temp == ANOTE ||
                                 temp == DNOTE || temp == GNOTE)){
      return MIDInum - 1;
    } 
    else if (keySig == -6 && (temp == BNOTE || temp == ENOTE || temp == ANOTE ||
                                 temp == DNOTE || temp == GNOTE || temp == CNOTE)){
      return MIDInum - 1;
    }
    else if (keySig == -7 && (temp == BNOTE || temp == ENOTE || temp == ANOTE ||
                temp == DNOTE || temp == GNOTE || temp == CNOTE || temp == FNOTE)){
      return MIDInum - 1;
    }

  }

  return 0;
}

